Index: cprs/trunk/CPRS-Chart/Orders/fODBBank.pas
===================================================================
--- cprs/trunk/CPRS-Chart/Orders/fODBBank.pas	(revision 456)
+++ cprs/trunk/CPRS-Chart/Orders/fODBBank.pas	(revision 829)
@@ -2111,45 +3160,394 @@
             FLastLabCollTime := ValidCollTime(Text);
           end;
+    end;
+end;
+
+procedure TfrmODBBank.cboCollTypeChange(Sender: TObject);
+begin
+  if (ALabTest = nil) or Changing or (cboCollType.ItemID = '') then exit;
+  if (cboCollType.ItemID = 'I') and (not ALabTest.LabCanCollect) then
+    begin
+      InfoBox(TX_NO_IMMED, TX_NO_IMMED_CAP, MB_OK or MB_ICONWARNING);
+      cboCollType.ItemIndex := -1;
+      Exit;
+    end;
+  if cboCollType.ItemID = 'I' then
+  begin
+    cboCollTime.ItemIndex := -1;
+    cboCollTime.Text := 'NOW';
+    calCollTime.Text := 'NOW';
+  end;
+  SetupCollTimes(cboCollType.ItemID);
+  if Length(cboCollType.Text) > 0 then Responses.Update('COLLECT',1,cboCollType.ItemID,cboCollType.ItemID);
+  FLastCollType := cboCollType.ItemID;
+  calCollTimeChange(self);
+end;
+
+procedure TfrmODBBank.cboModifiersChange(Sender: TObject);
+var
+  i: integer;
+  ListItem: TListItem;
+  x,q,m: string;
+begin
+  inherited;
+  if changing = true then Exit;
+  if (cboAvailComp.ItemIndex <> -1) and (uSelectedItems.Count > 0) then
+    begin
+      for i := 0 to lvSelectionList.Items.Count - 1 do
+        begin
+          x := uSelectedItems[i];
+          m := piece(x,'^',4);
+          q := piece(x,'^',3);
+          if lvSelectionList.Items[i].Caption = piece(cboAvailComp.Items[cboAvailComp.ItemIndex],'^',2) then
+            begin
+              ListItem := lvSelectionList.Items[i];
+              ListItem.SubItems.Clear;
+              ListItem.SubItems.Add(q);
+              if length(cboModifiers.ItemID) > 0 then
+                begin
+                  ListItem.SubItems.Add(cboModifiers.Items[cboModifiers.ItemIndex]);
+                  ListItem.SubItems.Add(IntToStr(cboModifiers.ItemIndex));
+                end
+                else
+                  begin
+                    ListItem.SubItems.Add('');
+                    ListItem.SubItems.Add('');
+                  end;
+              ListItem.SubItems.Add(piece(cboAvailComp.Items[cboAvailComp.ItemIndex],'^',1));
+              Responses.Update('MODIFIER', (i+1), cboModifiers.Text, cboModifiers.Text);
+              Break;
+            end;
+        end;
+    end;
+  if Length(cboModifiers.Text) > 0 then
+    begin
+      memOrder.Text := Responses.OrderText;
+    end;
+end;
+
+procedure TfrmODBBank.LoadModifiers(AComboBox:TORComboBox);
+var
+  i: integer;
+begin
+  with AComboBox do
+    begin
+      Clear;
+      for i := 0 to uModifierList.Count - 1 do
+           Items.Add(uModifierList[i]);
+    end;
+end;
+
+procedure TfrmODBBank.LoadReasons(AComboBox:TORComboBox);
+var
+  i: integer;
+begin
+  with AComboBox do
+    begin
+      Clear;
+      for i := 0 to uReasonsList.Count - 1 do
+           Items.Add(uReasonsList[i]);
+    end;
+end;
+
+procedure TfrmODBBank.LoadUrgencies(AComboBox:TORComboBox);
+var
+  i: integer;
+begin
+  with AComboBox do
+    begin
+      Clear;
+      for i := 0 to uUrgencyList.Count - 1 do
+         if (piece(uUrgencyList[i],'^',2) = 'STAT') and (StatAllowed(Patient.DFN) = false) then
+           Continue
+         else
+           Items.Add(uUrgencyList[i]);
+    end;
+end;
+
+procedure TfrmODBBank.lvSelectionListClick(Sender: TObject);
+var
+  ListItem: TListItem;
+  x,y: string;
+  i,j: integer;
+begin
+  inherited;
+  if lvSelectionList.Selected = nil then Exit;
+  ListItem := lvSelectionList.Selected;
+  changing := true;
+  tQuantity.Text := '';
+  cboModifiers.ItemIndex := -1;
+  i := lvSelectionList.ItemIndex;
+  j := 0;
+  if cboCollType.ItemID = 'LC' then
+    begin
+      if FLastLabCollTime <> '' then
+        cboCollTime.SelectByID(piece(FLastLabCollTime,'^',1));
     end
   else
     begin
-      with calCollTime do
-        if FMDateTime > 0 then
+      if FLastCollTime = 'TODAY' then
+        calCollTime.Text := FLastCollTime
+      else if FLastCollTime = 'NOW' then
+        calCollTime.Text := FLastCollTime
+      else if FLastCollTime <> '' then
+        calCollTime.Text := FormatFMDateTime('mmm dd,yyyy@hh:nn',StrToFMDateTime(FLastCollTime));
+    end;
+  if FLastCollType <> '' then
+    cboCollType.SelectByID(FLastCollType);
+  if uSelectedItems.Count > 0 then
+    begin
+      x := uSelectedItems[i];
+      ALabTest := TLabTest.Create(piece(uSelectedItems[i],'^',2), Responses);
+      if not(piece(x,'^',2) = '') then j := StrToInt(piece(x,'^',2));
+      if not(piece(x,'^',1) = '1') and (j > 0) then //Components
+        begin
+          DisableDiagTestControls;
+          EnableComponentControls;
+          y := ListItem.SubItems[2];
+          changing := true;
+          cboModifiers.Text := '';
+          cboAvailComp.SelectByIEN(j);
+          tQuantity.Text := ListItem.SubItems[0];
+          changing := false;
+          if y <> '' then cboModifiers.ItemIndex := StrToInt(y);
+        end
+      else                            //Diagnostic Tests
+        begin
+          DisableComponentControls;
+          EnableDiagTestControls;
+          cboAvailTest.SelectByIEN(j);
+        end;
+    end;
+  changing := false;
+end;
+
+procedure TfrmODBBank.memDiagCommentChange(Sender: TObject);
+begin
+  inherited;
+  if (length(memDiagComment.Text) > 250) then
+    begin
+      ShowMsg('COMMENT cannot be longer than 250 characters');
+      memDiagComment.Text := Copy(memDiagComment.Text,0,250);
+      Exit;
+    end;
+  if lvSelectionList.Items.Count < 1 then Exit;
+
+  if uSelectedItems = nil then Exit;
+  
+  if uSelectedItems.Count > 0 then
+    Responses.Update('COMMENT',1,memDiagComment.Text,memDiagComment.Text);
+  memOrder.Text := Responses.OrderText;
+end;
+
+procedure TfrmODBBank.FormDestroy(Sender: TObject);
+begin
+  inherited;
+  uSelectedItems.Free;
+  uVBECList.Free;
+  uTestsForResults.Free;
+  uUrgencyList.Free;
+  uTNSOrders.Free;
+  uModifierList.Free;
+  uReasonsList.Free;
+  uRaw.Free;
+end;
+
+procedure TfrmODBBank.btnRemoveClick(Sender: TObject);
+var
+  i,j,curAdd: integer;
+  x, aName, aModifier, aReason, aTypeScreen: string;
+  aList: TStringList;
+  aSel, aSelTst : boolean;
+begin
+  inherited;
+  aList := TStringList.Create;
+  try
+    curAdd := 1;
+    aModifier := '';
+    aReason := '';
+    aTypeScreen := '';
+    aSel := false;
+    aSelTst := false;
+    ExtractTypeScreen(aList, uVBECList);
+    if aList.Count > 0 then aTypeScreen := aList[0];
+    aList.Clear;
+    if length(cboModifiers.ItemID) > 0 then aModifier := cboModifiers.Items[cboModifiers.ItemIndex];
+    if length(cboReasons.ItemID) > 0 then aReason := cboReasons.Items[cboReasons.ItemIndex];
+    if lvSelectionList.Items.Count < 1 then
+      begin
+        ShowMsg('There is nothing in the list to remove.');
+        exit;
+      end;
+    cboAvailComp.ItemIndex := -1;
+    tQuantity.Text := '';
+    cboAvailTest.ItemIndex := -1;
+    uGetTnS := 0;
+    lblTNS.Caption := '';
+    lblTNS.Visible := false;
+    memMessage.Text := '';
+    pnlMessage.Visible := false;
+    pnlDiagnosticTests.Caption := 'Diagnostic Tests';
+    with lvSelectionList do
+      begin
+        for i := lvSelectionList.Items.Count - 1 downto 0 do
           begin
-            Responses.Update('START', 1, ValidCollTime(Text), Text);
-            FLastColltime := ValidCollTime(Text);
+            if lvSelectionList.Items[i].Selected = true then
+              begin
+                aSel := true;
+                for j := uSelectedItems.Count - 1 downto 0 do
+                  if lvSelectionList.Items[i].SubItems[3] = piece(uSelectedItems[j],'^',2) then
+                    begin
+                      {if (uGetTnS = 1) and (lvSelectionList.Items[i].SubItems[3] = aTypeScreen) then
+                        begin
+                          uGetTnS := 1;
+                          lblTNS.Caption := 'TYPE+SCREEN must be added to order';
+                          lblTNS.Visible := true;
+                          memMessage.Text := 'TYPE + SCREEN must be added to order';
+                          //memMessage.Visible := true;
+                          pnlMessage.Visible := true;
+                          pnlDiagnosticTests.Caption := 'Diagnostic Tests*';
+                        end; }
+                      uSelectedItems.Delete(j);
+                      lvSelectionList.Items[i].Delete;
+                      break;
+                    end;
+              end;
+          end;
+      end;
+    for i := uSelectedItems.Count - 1 downto 0 do
+      begin
+        if (not(piece(uSelectedItems[i],'^',1) = '1')) and (uTNSOrders.Count < 1) then // and (SpecimenNeeded(aList, uVBECList, StrToInt(piece(uSelectedItems[i],'^',9)))) then
+          begin
+            uGetTnS := 1;
+            lblTNS.Caption := 'TYPE+SCREEN must be added to order';
+            lblTNS.Visible := true;
+            memMessage.Text := 'TYPE + SCREEN must be added to order';
+            //memMessage.Visible := true;
+            pnlMessage.Visible := true;
+            pnlDiagnosticTests.Caption := 'Diagnostic Tests*';
+            break;
+          end;
+      end;
+      
+    if (aSel = false) and (lvSelectionList.Items.Count > 0) then
+      begin
+        ShowMsg('Please select an item from the list to be removed.');
+        exit;
+      end;
+    Responses.Clear;
+    if lvSelectionList.Items.Count < 1 then
+      begin
+        cboReasons.ItemIndex := -1;
+        memDiagComment.Text := '';
+        cboSurgery.ItemIndex := -1;
+        cboUrgency.ItemIndex := -1;
+        cboCollType.ItemIndex := -1;
+        cboCollTime.ItemIndex := -1;
+        cboQuick.ItemIndex := -1;
+        calCollTime.Text := '';
+      end;
+    for i := 0 to uSelectedItems.Count - 1 do
+      begin
+        aName := lvSelectionList.Items[i].Caption;
+        x := uSelectedItems[i];
+        if piece(x,'^',1) = '1' then    //Diagnostic Test related fields
+          begin
+            if Length(piece(x,'^',2)) > 0 then Responses.Update('ORDERABLE', CurAdd, piece(x,'^',2), aName);
+            aSelTst := true;
           end
         else
           begin
-            Responses.Update('START', 1, '', '') ;
-            FLastCollTime := '';
+            if Length(piece(x,'^',2)) > 0 then Responses.Update('ORDERABLE', CurAdd, piece(x,'^',2), aName);
+            if Length(piece(x,'^',3)) > 0 then Responses.Update('QTY', CurAdd, piece(x,'^',3), piece(x,'^',3));
+            if Length(piece(x,'^',4)) > 0 then Responses.Update('MODIFIER', CurAdd, piece(x,'^',4), aModifier);
+            if Length(piece(x,'^',5)) > 0 then Responses.Update('SPECSTS', CurAdd, pieces(x,'^',5,7), piece(x,'^',5));
+            cboModifiers.ItemIndex := -1;
+            cboAvailComp.ItemIndex := -1;
+            tQuantity.Text := '';
           end;
-    end;
-  with cboCollType do if Length(ItemID) > 0 then
-    begin
-      Responses.Update('COLLECT', 1, ItemID, ItemID) ;
-      FLastCollType := ItemID;
-    end;
-  if Length(cboUrgency.Text) > 0 then Responses.Update('URGENCY',1,cboUrgency.ItemID,cboUrgency.Text);
-  if Length(txtDiagComment.Text) > 0 then Responses.Update('COMMENT',1,txtDiagComment.Text,txtDiagComment.Text);
-  //if Length(cboPreparation.Text) > 0 then Responses.Update('XFUSION',1,cboPreparation.ItemID,cboPreparation.Text);
-  if Length(cboSurgery.Text) > 0 then Responses.Update('MISC',1,cboSurgery.Text,cboSurgery.Text);
-  if Length(tReason.Text) > 0 then Responses.Update('REASON',1,tReason.Text,tReason.Text);
-  if chkConsent.Checked = true then Responses.Update('YN',1,'1','Yes');
-  memOrder.Text := Responses.OrderText;
-  CurAdd := 1;
-  if uRaw.Count > 0 then
-    for j := 0 to uRaw.Count - 1 do
-      begin
-        if Length(uRaw[j]) > 0 then Responses.Update('RESULTS', CurAdd, uRaw[j], piece(uRaw[j],'^',1));
         Inc(CurAdd);
       end;
-  if uSelectedItems.Count < 1 then
-    begin
-      uGetTnS := 0;
-      lblTNS.Caption := '';
-      lblTNS.Visible := false;
-    end;
-  aList.Free;
+    if aSelTst = false then
+      begin
+        cboCollType.ItemIndex := -1;
+        cboCollTime.ItemIndex := -1;
+        calCollTime.Text := '';
+      end;
+    if Length(calWantTime.Text) > 0 then Responses.Update('DATETIME',1,ValidCollTime(calWantTime.Text),calWantTime.Text);
+    if cboCollType.ItemID = 'LC' then
+      begin
+        with cboCollTime do
+          if Length(ItemID) > 0 then
+            begin
+              Responses.Update('START', 1, Copy(ItemID, 2, 999), Copy(ItemID, 2, 999));
+              FLastLabCollTime := ItemID + U + Text;
+            end
+          else if Length(Text) > 0 then
+            begin
+              Responses.Update('START', 1, ValidCollTime(Text), Text) ;
+              FLastLabCollTime := ValidCollTime(Text);
+            end;
+      end
+    else
+      begin
+        with calCollTime do
+          if FMDateTime > 0 then
+            begin
+              Responses.Update('START', 1, ValidCollTime(Text), Text);
+              FLastColltime := ValidCollTime(Text);
+            end
+          else
+            begin
+              Responses.Update('START', 1, '', '') ;
+              FLastCollTime := '';
+            end;
+      end;
+    with cboCollType do if Length(ItemID) > 0 then
+      begin
+        Responses.Update('COLLECT', 1, ItemID, ItemID) ;
+        FLastCollType := ItemID;
+      end;
+    if Length(cboUrgency.Text) > 0 then Responses.Update('URGENCY',1,cboUrgency.ItemID,cboUrgency.Text);
+    if Length(memDiagComment.Text) > 0 then Responses.Update('COMMENT',1,memDiagComment.Text,memDiagComment.Text);
+    if Length(cboSurgery.Text) > 0 then Responses.Update('MISC',1,cboSurgery.Text,cboSurgery.Text);
+    if Length(cboReasons.Text) > 0 then Responses.Update('REASON',1,cboReasons.Text,cboReasons.Text);
+    if chkConsent.Checked = true then Responses.Update('YN',1,'1','Yes');
+    memOrder.Text := Responses.OrderText;
+    CurAdd := 1;
+    if uRaw.Count > 0 then
+      for j := 0 to uRaw.Count - 1 do
+        begin
+          if Length(uRaw[j]) > 0 then Responses.Update('RESULTS', CurAdd, uRaw[j], piece(uRaw[j],'^',1));
+          Inc(CurAdd);
+        end;
+    if uSelectedItems.Count < 1 then
+      begin
+        uGetTnS := 0;
+        lblTNS.Caption := '';
+        lblTNS.Visible := false;
+        memMessage.Text := '';
+        pnlMessage.Visible := false;
+        GroupBox1.Visible := true;
+        pnlDiagnosticTests.Caption := 'Diagnostic Tests';
+      end;
+  finally
+    aList.Free;
+  end;
+end;
+
+procedure TfrmODBBank.btnUpdateCommentsClick(Sender: TObject);
+begin
+  inherited;
+  pnlComments.Visible := false;
+  pnlComments.SendToBack;
+  Responses.Update('COMMENT',1,memDiagComment.Text,memDiagComment.Text);
+  memOrder.Text := Responses.OrderText;
+end;
+
+procedure TfrmODBBank.btnCancelCommentClick(Sender: TObject);
+begin
+  inherited;
+  pnlComments.Visible := false;
+  pnlComments.SendToBack;
 end;
 
@@ -2157,4 +3555,9 @@
 begin
   inherited;
+  if lvSelectionList.Items.Count < 1 then
+    begin
+      ShowMsg('There is nothing in the list to remove.');
+      exit;
+    end;
   lvSelectionList.Clear;
   uSelectedItems.Clear;
@@ -2164,5 +3567,24 @@
   lblTNS.Caption := '';
   lblTNS.Visible := false;
+  memMessage.Text := '';
+  pnlMessage.Visible := false;
   InitDialog;
+  cboModifiers.ItemIndex := -1;
+  cboAvailTest.ItemIndex := -1;
+  cboAvailComp.ItemIndex := -1;
+  cboSurgery.ItemIndex := -1;
+  cboUrgency.ItemIndex := -1;
+  cboReasons.ItemIndex := -1;
+  cboCollType.ItemIndex := -1;
+  cboCollTime.ItemIndex := -1;
+  cboQuick.ItemIndex := -1;
+  calWantTime.Text := '';
+  memDiagComment.Text := '';
+  GroupBox1.Visible := true;
+  tQuantity.Text := '';
+  FLastCollType := '';
+  FLastCollTime := '';
+  FLastLabCollTime := '';
+  txtImmedColl.Text := '';
 end;
 
@@ -2175,4 +3597,5 @@
   Txt2 = #13+#13+'An order for TYPE and SCREEN must be created with this order set.';
 begin
+  if not ValidAdd then Exit;
   if uGetTnS = 1 then
     begin
@@ -2191,5 +3614,8 @@
     end;
   if Comp = true then
-    ShowMessage('The nursing blood administration order must be entered separately' + '.');
+    begin
+      if NursAdminSuppress = true then
+        ShowMsg('The nursing blood administration order must be entered separately' + '.');
+    end;
   inherited;
 end;
@@ -2199,5 +3625,31 @@
   inherited;
   if uSelectedItems.Count > 0 then
-    if Length(calWantTime.Text) > 0 then Responses.Update('DATETIME',1,ValidCollTime(calWantTime.Text),calWantTime.Text);
+    begin
+      with calWantTime do if not Changing then
+        begin
+          if FMDateTime = 0 then
+            begin
+              ShowMsg('Invalid Date/Time entered');
+              Changing := true;
+              calWantTime.Text := '';
+              Changing := false;
+              Exit;
+            end
+          else
+            begin
+              // date/time was entered
+              if (UpperCase(Text) <> 'NOW') and not(Trunc(FMNow) = Trunc(FMDateTime)) and (FMDateTime < FMNow) then
+                begin
+                  ShowMsg('Date/Time Wanted must be a future Date/Time');
+                  Changing := true;
+                  calWantTime.Text := '';
+                  Changing := false;
+                  Exit;
+                end;
+            end;
+        end;
+      if Length(calWantTime.Text) > 0 then Responses.Update('DATETIME',1,ValidCollTime(calWantTime.Text),calWantTime.Text);
+      memOrder.Text := Responses.OrderText;
+    end;
 end;
 
@@ -2207,6 +3659,6 @@
   if uSelectedItems.Count > 0 then
     begin
-      if chkConsent.Checked = true then Responses.Update('YN',1,'1','Yes')
-      else Responses.Update('YN',1,'0','No');
+      if chkConsent.Checked = true then Responses.Update('YN',1,'1','Yes');
+      memOrder.Text := Responses.OrderText;
     end;
 end;
@@ -2218,8 +3670,10 @@
     begin
       Responses.Update('URGENCY',1,cboUrgency.ItemID,cboUrgency.Text);
+      uSelUrgency := cboUrgency.Text;
       if cboUrgency.Text = 'PRE-OP' then
         begin
           lblSurgery.Enabled := true;
           cboSurgery.Enabled := true;
+          lblSurgery.Caption := 'Surgery*';
         end
       else
@@ -2227,41 +3681,254 @@
           lblSurgery.Enabled := false;
           cboSurgery.Enabled := false;
-          cboSurgery.Text := '';
-          if uSelectedItems.Count > 0 then
-            Responses.Update('MISC',1,cboSurgery.Text,cboSurgery.Text);
+          lblSurgery.Caption := 'Surgery';
+          cboSurgery.ItemIndex := -1;
+          Responses.Update('MISC',1,cboSurgery.Text,cboSurgery.Text);
         end;
-    end;
-end;
-
-procedure TfrmODBBank.txtDiagCommentChange(Sender: TObject);
+    end
+  else
+    cboUrgency.SelectByID(IntToStr(uDfltUrgency));
+  memOrder.Text := Responses.OrderText;
+end;
+
+procedure TfrmODBBank.cboUrgencyExit(Sender: TObject);
 begin
   inherited;
-  if uSelectedItems.Count > 0 then
-    Responses.Update('COMMENT',1,txtDiagComment.Text,txtDiagComment.Text);
-end;
-
-procedure TfrmODBBank.cboPreparationChange(Sender: TObject);
+  if Length(cboUrgency.Text) < 1 then
+    cboUrgency.SelectByID(IntToStr(uDfltUrgency));
+end;
+
+procedure TfrmODBBank.cboSurgeryChange(Sender: TObject);
+var
+  aList: TStringList;
+  i,j,aMSBOS,aMSBOSContinue: integer;
+  x: string;
+  handled: boolean;
 begin
   inherited;
-  Exit;  // disable Preparation, since it is no longer needed by VBECS
-  if uSelectedItems.Count > 0 then
-    if Length(cboPreparation.Text) > 0 then
-      Responses.Update('XFUSION',1,cboPreparation.ItemID,cboPreparation.Text);
-end;
-
-procedure TfrmODBBank.cboSurgeryChange(Sender: TObject);
+  aList := TStringList.Create;
+  handled := false;
+  try
+    if (Length(cboSurgery.ItemID) > 0) and (Length(tQuantity.Text) > 0) then
+      begin
+        aList.Clear;
+        ExtractMSBOS(aList, uVBECList);    //Get maximum units for selected Surgey
+        for i := 0 to aList.Count - 1 do
+          begin
+            if (StrToInt(piece(aList[i],'^',1)) = aLabTest.ItemID)
+             and (piece(aList[i],'^',3) = cboSurgery.Text) then
+              begin
+                aMSBOS := StrToInt(piece(aList[i],'^',4));
+                if (aMSBOS > 0) and (StrToInt(tQuantity.Text) > aMSBOS) then
+                  begin
+                    with Application do
+                    begin
+                      NormalizeTopMosts;
+                      aMSBOSContinue :=
+                        MessageBox(PChar('The number of unit Quantity selected (' + tQuantity.Text +
+                                   ') for ' + aLabTest.TestName + ' exceeds the maximum number of units ('
+                                   + IntToStr(aMSBOS) +
+                                   ') for the ' + cboSurgery.text +
+                                   ' surgical procedure selected.' + CRLF + CRLF + 'Continue to order ' + tQuantity.Text + ' units?'),
+                                   PChar('Maximum Number of Units Exceeded'),
+                                   MB_YESNO);
+                      RestoreTopMosts;
+                    end;
+                    if aMSBOSContinue = 7 then
+                      begin
+                        ShowMsg('Please enter a new quantity for ' + cboAvailComp.Text);
+                        tQuantity.Text := '0';
+                        tQuantity.SelLength := 2;
+                        tQuantity.SelectAll;
+                        break;
+                      end;
+                  end;
+                handled := true;
+                break;
+              end;
+          end;
+      end;
+    if (handled = false) and (Length(cboSurgery.ItemID) > 0) and (uSelectedItems.Count > 0) then
+      begin
+        aList.Clear;
+        ExtractMSBOS(aList, uVBECList);    //Get maximum units for selected Surgey
+        for j := 0 to uSelectedItems.Count - 1 do
+          begin
+            ALabTest := TLabTest.Create(piece(uSelectedItems[j],'^',2), Responses);
+            for i := 0 to aList.Count - 1 do
+              begin
+                if (piece(uSelectedItems[j],'^',1) = '0')
+                 and (StrToInt(piece(aList[i],'^',1)) = aLabTest.ItemID)
+                 and (piece(aList[i],'^',3) = cboSurgery.Text) then
+                  begin
+                    aMSBOS := StrToInt(piece(aList[i],'^',4));
+                    if (aMSBOS > 0) and (length(piece(uSelectedItems[j],'^',3)) > 0) and (StrToInt(piece(uSelectedItems[j],'^',3)) > aMSBOS) then
+                      begin
+                        with Application do
+                        begin
+                          NormalizeTopMosts;
+                          aMSBOSContinue :=
+                            MessageBox(PChar('The number of unit Quantity selected (' + piece(uSelectedItems[j],'^',3) +
+                               ') for ' + lvSelectionList.Items[j].Caption + ' exceeds the maximum number of units ('
+                               + IntToStr(aMSBOS) +
+                               ') for the ' + cboSurgery.text +
+                               ' surgical procedure selected.' + CRLF + CRLF + 'Continue to order ' + piece(uSelectedItems[j],'^',3) + ' units?'),
+                               PChar('Maximum Number of Units Exceeded'),
+                               MB_YESNO);
+                          RestoreTopMosts;
+                        end;
+                        if aMSBOSContinue = 7 then
+                          begin
+                            ShowMsg('Please enter a new quantity for ' + lvSelectionList.Items[j].Caption);
+                            tQuantity.Text := '0';
+                            tQuantity.SelLength := 2;
+                            tQuantity.SelectAll;
+                            x := uSelectedItems[j];
+                            SetPiece(x,U,3,'');
+                            uSelectedItems[j] := x;
+                            lvSelectionList.Items[j].SubItems[0] := '';
+                            RePaint;
+                            break;
+                          end;
+                      end;
+                    break;
+                  end;
+              end;
+          end;
+      end;
+    if uSelectedItems.Count > 0 then
+      if Length(cboSurgery.Text) > 0 then
+        Responses.Update('MISC',1,cboSurgery.Text,cboSurgery.Text);
+    uSelSurgery := 0;
+    if Length(cboSurgery.Text) > 0 then
+      begin
+        if length(cboSurgery.ItemID) > 0 then uSelSurgery := cboSurgery.ItemID;
+        cboReasons.Text := cboSurgery.Text;
+        Responses.Update('REASON',1,cboReasons.Text,cboReasons.Text);
+      end;
+    memOrder.Text := Responses.OrderText; 
+    finally
+      aList.Free;
+    end;
+end;
+
+procedure TfrmODBBank.cboSurgeryClick(Sender: TObject);
 begin
   inherited;
-  if uSelectedItems.Count > 0 then
-    if Length(cboSurgery.Text) > 0 then
-      Responses.Update('MISC',1,cboSurgery.Text,cboSurgery.Text);
-end;
-
-procedure TfrmODBBank.tReasonChange(Sender: TObject);
+  if Length(cboSurgery.Text) > 0 then uSelSurgery := cboSurgery.ItemID;
+end;
+
+procedure TfrmODBBank.tQuantityChange(Sender: TObject);
+var
+  aList: TStringList;
+  i,aMSBOS,aMSBOSContinue: integer;
+  ListItem: TListItem;
+  x,m: string;
 begin
   inherited;
-  if uSelectedItems.Count > 0 then
-    if Length(tReason.Text) > 0 then
-      Responses.Update('REASON',1,tReason.Text,tReason.Text);
+  if changing = true then Exit;
+  aList := TStringList.Create;
+  if Length(tQuantity.Text) > 0 then
+    begin
+      if Length(tQuantity.Text) > 2 then
+        begin
+          ShowMsg('Invalid entry. Please select a numeric value <100');
+          tQuantity.Text := '';
+          Exit;
+        end;
+      if StrToInt(tQuantity.Text) > 100 then
+        begin
+          ShowMsg('Quantity too high. Please select a value <100');
+          tQuantity.Text := Copy(tQuantity.Text,0,1);
+          Exit;
+        end;
+    end;
+  try
+    if (Length(cboSurgery.ItemID) > 0) and (Length(tQuantity.Text) > 0) then
+      begin
+        aList.Clear;
+        ExtractMSBOS(aList, uVBECList);    //Get maximum units for selected Surgery
+        for i := 0 to aList.Count - 1 do
+          begin
+            if (StrToInt(piece(aList[i],'^',1)) = aLabTest.ItemID)
+             and (piece(aList[i],'^',3) = cboSurgery.Text) then
+              begin
+                aMSBOS := StrToInt(piece(aList[i],'^',4));
+                if (aMSBOS > 0) and (StrToInt(tQuantity.Text) > aMSBOS) then
+                  begin
+                    with Application do
+                    begin
+                      NormalizeTopMosts;
+                      aMSBOSContinue :=
+                        MessageBox(PChar('The number of units ordered (' + tQuantity.Text +
+                                   ') for ' + aLabTest.TestName + ' exceeds the maximum number of units ('
+                                   + IntToStr(aMSBOS) +
+                                   ') for the ' + cboSurgery.text +
+                                   ' surgical procedure selected.' + CRLF + CRLF + 'Do you wish to continue?'),
+                                   PChar('Maximum Number of Units Exceeded'),
+                                   MB_YESNO);
+                      RestoreTopMosts;
+                    end;
+                    if aMSBOSContinue = 7 then
+                      begin
+                        ShowMsg('Please enter a new quantity for ' + cboAvailComp.Text);
+                        tQuantity.Text := '0';
+                        tQuantity.SelLength := 2;
+                        tQuantity.SelectAll;
+                        break;
+                      end;
+                  end;
+                break;
+              end;
+          end;
+      end;
+    if (cboAvailComp.ItemIndex <> -1) and (uSelectedItems.Count > 0) then
+      for i := 0 to lvSelectionList.Items.Count - 1 do
+        begin
+          if lvSelectionList.Items[i].Caption = piece(cboAvailComp.Items[cboAvailComp.ItemIndex],'^',2) then
+            begin
+              x := uSelectedItems[i];
+              m := piece(x,'^',4);
+              ListItem := lvSelectionList.Items[i];
+              ListItem.SubItems.Clear;
+              ListItem.SubItems.Add(tQuantity.Text);
+              SetPiece(x,U,3,tQuantity.Text);
+              Responses.Update('QTY', (i+1), tQuantity.Text, tQuantity.Text);
+              uSelectedItems[i] := x;
+              if length(cboModifiers.ItemID) > 0 then
+                begin
+                  ListItem.SubItems.Add(cboModifiers.Items[cboModifiers.ItemIndex]);
+                  ListItem.SubItems.Add(IntToStr(cboModifiers.ItemIndex));
+                end
+                else
+                  begin
+                    ListItem.SubItems.Add('');
+                    ListItem.SubItems.Add('');
+                  end;
+
+              ListItem.SubItems.Add(piece(cboAvailComp.Items[cboAvailComp.ItemIndex],'^',1));
+              Break;
+            end;
+        end;
+    if Length(tQuantity.Text) > 0 then
+      begin
+        memOrder.Text := Responses.OrderText;
+      end;
+  finally
+    aList.Free;
+  end;
+end;
+
+procedure TfrmODBBank.tQuantityClick(Sender: TObject);
+begin
+  inherited;
+  tQuantity.SelLength := 2;
+  tQuantity.SelectAll;
+end;
+
+procedure TfrmODBBank.tQuantityEnter(Sender: TObject);
+begin
+  inherited;
+  tQuantity.SelLength := 2;
+  tQuantity.SelectAll;
 end;
 
@@ -2299,4 +3966,5 @@
               end;
         end;
+      memOrder.Text := Responses.OrderText;
     end;
 end;
